#include <bits/stdc++.h>
#define endl "\n"
#define pii pair<int, int>
#define ff first
#define ss second
using namespace std;

const int maxn = 2e3+3;

int matrix[maxn][maxn];
int rows[maxn][maxn], n;

int fxb = -1, fxe = -1, fyb = -1, fye = -1;
bool in_bounds(const int& x, const int& y)
{
    if(x < fxb || fxe < x || y < fyb || fye < y) return false;
    return true;
}
void print(int mtx[maxn][maxn]);
void print(int arr[maxn]);
struct fenw2
{
    int n;
    vector<vector<int> > tree;

    fenw2() {}
    fenw2(int n): n(n), tree(n+2, vector<int>(n+2, 0)) {}

    void add(int ix, int iy, int v)
    {
        for(; ix <= n; ix += ix & (-ix))
        for(int iiy = iy; iiy <= n; iiy += iiy & (-iiy))
            tree[ix][iiy] += v;
    }

    int sum(int ix, int iy)
    {
        int s = 0;
        for(; ix >= 1; ix -= ix & (-ix))
        for(int iiy = iy; iiy >= 1; iiy -= iiy & (-iiy))
            s += tree[ix][iiy];
        return s;
    }

    int sum(int ix, int iy, int jx, int jy)
    {
        return sum(jx, jy) - sum(jx, iy-1) - sum(ix-1, jy) + sum(ix-1, iy-1);
    }
};

fenw2 field;

void input()
{
    char c;
    cin >> n;
    field = fenw2(n);
    for(int i = 1; i <= n; i++)
    for(int j = 1; j <= n; j++)
    {
        cin >> c;
        if(matrix[i][j] = (c == '1'))
            field.add(i, j, 1);
    }
}

void do_rows()
{
    for(int i = 1; i <= n; i++)
    for(int j = 1; j <= n; j++)
    {
        rows[i][j] = (rows[i][j-1] + 1) * (matrix[i][j] ^ in_bounds(i, j));
    }
}

int minleft[maxn], minright[maxn];
int do_column(int j)
{
    stack<pii> st;

    // left to right
    for(int i = 1; i <= n; i++)
    {
        while(!st.empty() && rows[i][j] <= st.top().ff)
            st.pop();
        if(st.empty()) minleft[i] = 0;
        else minleft[i] = st.top().ss;
        st.push({rows[i][j], i});
    }

    while(!st.empty()) st.pop();

    // right to left
    for(int i = n; i >= 1; i--)
    {
        while(!st.empty() && rows[i][j] <= st.top().ff)
            st.pop();
        if(st.empty()) minright[i] = n+1;
        else minright[i] = st.top().ss;
        st.push({rows[i][j], i});
    }

    // cout << j << ":\n";
    // print(minleft), print(minright); cout << endl;

    int result = 0;
    for(int i = 1; i <= n; i++)
        result = max(result, (minright[i] - minleft[i] - 1) * rows[i][j]);
    return result;
}

int do_columns()
{
    int result = 0;
    for(int j = 1; j <= n; j++)
        result = max(result, do_column(j));
    return result;
}

int calculate()
{
    do_rows();
    return do_columns();
}

void attempt_to_solve()
{
    int result = calculate();
    for(int lowx = 1; lowx <= n; lowx++)
    for(int lowy = 1; lowy <= n; lowy++)
    {
        if(matrix[lowx][lowy]) continue;
        for(int highx = lowx; highx <= n; highx++)
        {
            if(field.sum(lowx, lowy, highx, lowy)) continue;
            for(int highy = lowy; highy <= n; highy++)
            {
                if(field.sum(lowx, lowy, highx, highy)) continue;
                fxb = lowx, fxe = highx, fyb = lowy, fye = highy;
                result = max(result, calculate());
//                int c = calculate();
//                if(result < c)
//                {
//                    result = c;
//                    cout << lowx << " " << lowy << " "
//                         << highx << " " << highy
//                         << " " << result << endl;
//                    print(rows);
//                }
            }
        }
    }
    cout << result << endl;
}

int main()
{
    // freopen("rectangle_input.txt", "r", stdin);
    input();
    attempt_to_solve();
    return 0;
}

void print(int mtx[maxn][maxn])
{
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            cout << mtx[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
}

void print(int arr[maxn])
{
    for(int j = 1; j <= n; j++)
    {
        cout << arr[j] << " ";
    }
    cout << endl;
}
