#include "treeq.h"
#include <vector>
#include <time.h>
#include <random>
#include <algorithm>
using namespace std;
const int MAXN=2e3+10;
vector <int> v[MAXN], ch[MAXN];
int par[MAXN], d[MAXN];
bool seen[MAXN], used[MAXN], tried[MAXN];
int root(int x) {
    if (par[x]==x) return x;
    return root(par[x]);
}
void union_roots(int r1, int r2) {
    ///cout << "union " << r1 << ' ' << r2 << endl;
    par[r2]=r1;
    for (auto i:v[r2]) v[r1].push_back(i);
}
bool my_query(int a, int b, int c) {
    vector <int> q;
    q.push_back(a); q.push_back(b);
    return query(q,c);
}
int find_child(int x, int cur_root) {
    used[x]=true;
    random_shuffle(ch[x].begin(),ch[x].end());
    for (auto i:ch[x]) {
        if (used[i]) continue;
        if (my_query(cur_root,x,i)) return find_child(i,cur_root);
    }
    return x;
}
int f(vector <int> cur) {
    if (cur.size()<=2) {
        if (cur.size()==2) {
            answer(cur[0],cur[1]);
            ch[cur[0]].push_back(cur[1]);
            ch[cur[1]].push_back(cur[0]);
        }
        return cur[0];
    }
    for (auto i:cur) {
        par[i]=i;
        if (!v[i].empty()) v[i].clear();
        v[i].push_back(i);
        tried[i]=false;
    }
    random_shuffle(cur.begin(),cur.end());
    int cur_root=cur[0];
    vector <int> q;
    ///cout << "root " << cur_root << endl;
    bool fl=true;
    for (int jump=1;jump<cur.size();jump=(jump<<1)) {
        for (int i=cur.size()-1;i-jump>0;i--) {
            int x=cur[i], y=cur[i-jump];
            x=root(x); y=root(y);
            ///cout << cur[i] << ' ' << cur[i-jump] << ' ' << x << ' ' << y << ' ' << jump << endl;
            if (!my_query(x,y,cur_root)) fl=false;
        }
    }
    if (!fl) {
        for (auto i:cur) {
            if (i==cur_root || tried[i]) continue;
            for (int j:cur) {
                if (j==cur_root || i==j || tried[j]) continue;
                ///cout << i << ' ' << j << ' ' << r1 << ' ' << r2 << endl;
                if (!my_query(i,j,cur_root)) {
                    v[i].push_back(j);
                    tried[j]=true;
                }
            }
            seen[i]=false;
        }
    }
    if (!q.empty()) q.clear();
    for (int i:cur) {
        if (i==cur_root || tried[i]) continue;
        if (seen[i]) continue;
        seen[i]=true;
        q.push_back(i);
    }
    vector <int> h;
    for (auto i:q) {
        h=v[i];
        int child=f(v[i]);
        for (auto j:h) used[j]=false;
        ///cout << "search " << cur_root << ' ' << child << endl;
        child=find_child(child,cur_root);
        ///cout << cur_root << " real child: " << child << endl;
        answer(cur_root,child);
        ch[cur_root].push_back(child);
        ch[child].push_back(cur_root);
    }
    return cur_root;
}
void solve(int n) {
    vector <int> start;
    for (int i=1;i<=n;i++) start.push_back(i);
    f(start);
}
