#include "treeq.h"
#include <vector>
#include <time.h>
#include <random>
#include <algorithm>
using namespace std;
const int MAXN=2e3+10;
vector <int> v[MAXN], ch[MAXN];
int par[MAXN], d[MAXN];
bool seen[MAXN], used[MAXN], tried[MAXN];
int root(int x) {
    if (par[x]==x) return x;
    return par[x]=root(par[x]);
}
void union_roots(int r1, int r2) {
    ///cout << "union " << r1 << ' ' << r2 << endl;
    if (d[r1]>d[r2]) swap(r1,r2);
    par[r1]=r2;
    if (d[r1]==d[r2]) d[r2]++;
    for (auto i:v[r1]) v[r2].push_back(i);
}
int find_child(int x, int cur_root) {
    vector <int> q;
    used[x]=true;
    random_shuffle(ch[x].begin(),ch[x].end());
    for (auto i:ch[x]) {
        if (used[i]) continue;
        if (!q.empty()) q.clear();
        q.push_back(cur_root); q.push_back(x);
        if (query(q,i)) return find_child(i,cur_root);
    }
    return x;
}
int f(vector <int> cur) {
    if (cur.size()<=2) {
        if (cur.size()==2) {
            answer(cur[0],cur[1]);
            ch[cur[0]].push_back(cur[1]);
            ch[cur[1]].push_back(cur[0]);
        }
        return cur[0];
    }
    for (auto i:cur) {
        par[i]=i;
        if (!v[i].empty()) v[i].clear();
        v[i].push_back(i);
        d[i]=1;
        tried[i]=false;
    }
    ///random_shuffle(cur.begin(),cur.end());
    int cur_root=cur[0];
    vector <int> q;
    ///cout << "root " << cur_root << endl;
    for (auto i:cur) {
        if (i==cur_root || tried[i]) continue;
        for (int j:cur) {
            if (j==cur_root || i==j || tried[j]) continue;
            ///cout << i << ' ' << j << ' ' << r1 << ' ' << r2 << endl;
            if (!q.empty()) q.clear();
            q.push_back(i); q.push_back(j);
            if (!query(q,cur_root)) {
                v[i].push_back(j);
                tried[j]=true;
            }
        }
        seen[i]=false;
    }
    if (!q.empty()) q.clear();
    for (int i:cur) {
        if (i==cur_root || tried[i]) continue;
        if (seen[i]) continue;
        seen[i]=true;
        q.push_back(i);
    }
    vector <int> h;
    for (auto i:q) {
        h=v[i];
        int child=f(v[i]);
        for (auto j:h) used[j]=false;
        ///cout << "search " << cur_root << ' ' << child << endl;
        child=find_child(child,cur_root);
        ///cout << cur_root << " real child: " << child << endl;
        answer(cur_root,child);
        ch[cur_root].push_back(child);
        ch[child].push_back(cur_root);
    }
    return cur_root;
}
void solve(int n) {
    vector <int> start;
    for (int i=1;i<=n;i++) start.push_back(i);
    f(start);
}
