#include <iostream>
#include <vector>
#include <utility>
#include <random>
#include <algorithm>

#include "treeq.h"

using namespace std;

vector<pair<int, int>> edges;

void solve(int n) {
    std::random_device rd;
    std::mt19937 g(rd());

    vector<int> nodes(n);
    for (int i = 0; i < n; ++i)
    {
        nodes[i] = i + 1;
    }

    for (int from = 1; from <= n and (int) edges.size() < n - 1; ++from)
    {
        for (int to = from + 1; to <= n and (int) edges.size() < n - 1; ++to)
        {
            bool is_edge = true;

            shuffle(nodes.begin(), nodes.end(), g);

            for (int special : nodes)
            {
                if (from == special or to == special)
                {
                    continue;
                }

                if (query({from, to}, special))
                {
                    is_edge = false;
                    break;
                }
            }

            if (is_edge)
            {
                edges.push_back({from, to});
            }
        }
    }

    for (pair<int, int> edge : edges)
    {
        answer(edge.first, edge.second);
    }
}
