#include <iostream>
#include <vector>
#include <utility>
#include <random>
#include <algorithm>
#include <set>

#include "treeq.h"

using namespace std;

vector<pair<int, int>> edges;
vector<int> leaves;

void remove_node(vector<int>& nodes, int target)
{
    for (int i = 0; i < (int) nodes.size(); ++i)
    {
        if (nodes[i] == target)
        {
            nodes.erase(nodes.begin() + i);
            return;
        }
    }
}

void found_leaves(vector<int>& nodes, int n)
{
    for (int i = 1; i <= n; ++i)
    {
        remove_node(nodes, i);

        if (!query(nodes, i))
        {
            leaves.push_back(i);
        }

        nodes.push_back(i);
    }

    for (int leaf : leaves)
    {
        remove_node(nodes, leaf);
    }
}

void solve(int n) {
    vector<int> nodes(n);
    for (int i = 0; i < n; ++i)
    {
        nodes[i] = i + 1;
    }

    found_leaves(nodes, n);

    vector<int> current_level;
    for (int leaf : leaves)
    {
        current_level.push_back(leaf);
    }

    for (int steps = 0; (int) edges.size() < n - 1; ++steps)
    {
        set<int> next_level;

        /*if (steps < 4)
        {
            cout << "nodes -> ";
            for (int nz : nodes)
            {
                cout << nz << " ";
            }
            cout << endl;
            cout << "current level -> ";
            for (int nz : current_level)
            {
                cout << nz << " ";
            }
            cout << endl << endl;
        }*/

        for (int from : current_level)
        {
            if ((int) edges.size() == n - 1)
            {
                continue;
            }

            for (int to : nodes)
            {
                if ((int) edges.size() == n - 1 or from == to)
                {
                    continue;
                }

                bool is_edge = true;

                for (int special : nodes)
                {
                    if (from == special or to == special)
                    {
                        continue;
                    }

                    // cout << "query: (" << from << ", " << to << ") " << special << endl;

                    if (query({from, to}, special))
                    {
                        is_edge = false;
                        break;
                    }
                }

                if (is_edge)
                {
                    // cout << "found edge -> (" << from << ", " << to << ") " << endl;
                    edges.push_back({from, to});
                    next_level.insert(to);
                }
            }
        }

        for (int old_node : current_level)
        {
            remove_node(nodes, old_node);
        }

        current_level.clear();

        for (int new_node : next_level)
        {
            current_level.push_back(new_node);
        }
    }

    for (pair<int, int> edge : edges)
    {
        answer(edge.first, edge.second);
    }
}
