#include <iostream>
#include <bitset>

#define endl '\n'

using namespace std;

const int MAXN = 3e3 + 3;
const int MAX_BITS = 3e3 + 3;

bool target[MAX_BITS];
int limits[MAXN];

int counter[MAX_BITS];

int result;

void solve(int step, int n, int b)
{
    if (step == n)
    {
        bool is_valid = true;

        for (int i = 0; i < b; ++i)
        {
            is_valid &= (counter[i] % 2 == target[i]);
        }

        result += is_valid;

        return;
    }

    for (int curr = 0; curr <= limits[step]; ++curr)
    {
        bitset<64> bits(curr);

        for (int i = 0; i < b; ++i)
        {
            counter[i] += bits[i];
        }

        solve(step + 1, n, b);

        for (int i = 0; i < b; ++i)
        {
            counter[i] -= bits[i];
        }
    }
}

int main()
{
    int n, b;
    cin >> n >> b;

    for (int i = 0; i < b; ++i)
    {
        char bit;
        cin >> bit;

        target[i] = bit - '0';
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < b; ++j)
        {
            char bit;
            cin >> bit;

            limits[i] = 2 * limits[i] + bit - '0';
        }
    }

    solve(0, n, b);

    cout << result << endl;

    return 0;
}
