#include <iostream>

#define endl '\n'

using namespace std;

const int MAXN = 2e3 + 3;

bool table[MAXN][MAXN];

int max_rect[MAXN][MAXN][2];

int row_streak[MAXN][MAXN];
int col_streak[MAXN][MAXN];

void change_table(int start_row, int start_col, int end_row, int end_col)
{
    for (int i = start_row; i <= end_row; ++i)
    {
        for (int j = start_col; j <= end_col; ++j)
        {
            table[i][j] = !table[i][j];
        }
    }
}

int calculate_max_rect(int n)
{
    int result = 0;

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            if (!table[i][j])
            {
                max_rect[i][j][0] = max_rect[i][j][1] = 0;
                row_streak[i][j] = col_streak[i][j] = 0;
                continue;
            }

            max_rect[i][j][0] = max_rect[i][j][1] = 1;
            row_streak[i][j] = col_streak[i][j] = 1;

            if (i > 0)
            {
                row_streak[i][j] += row_streak[i - 1][j];
            }

            if (j > 0)
            {
                col_streak[i][j] += col_streak[i][j - 1];
            }

            if (i > 0)
            {
                int new_rows = max_rect[i - 1][j][0] + 1;
                int new_cols = min(col_streak[i][j], max_rect[i - 1][j][1]);

                if (new_rows * new_cols > max_rect[i][j][0] * max_rect[i][j][1])
                {
                    max_rect[i][j][0] = new_rows;
                    max_rect[i][j][1] = new_cols;
                }
            }

            if (j > 0)
            {
                int new_rows = min(row_streak[i][j], max_rect[i][j - 1][0]);
                int new_cols = max_rect[i][j - 1][1] + 1;

                if (new_rows * new_cols > max_rect[i][j][0] * max_rect[i][j][1])
                {
                    max_rect[i][j][0] = new_rows;
                    max_rect[i][j][1] = new_cols;
                }
            }

            result = max(result, max_rect[i][j][0] * max_rect[i][j][1]);
        }
    }

    return result;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            char cell;
            cin >> cell;

            table[i][j] = cell - '0';
        }
    }

    int result = calculate_max_rect(n);

    for (int start_row = 0; start_row < n; ++start_row)
    {
        for (int start_col = 0; start_col < n; ++start_col)
        {
            for (int end_row = start_row; end_row < n; ++end_row)
            {
                for (int end_col = start_col; end_col < n; ++end_col)
                {
                    change_table(start_row, start_col, end_row, end_col);
                    result = max(result, calculate_max_rect(n));
                    change_table(start_row, start_col, end_row, end_col);
                }
            }
        }
    }

    cout << result << endl;

    return 0;
}
