#include "treeq.h"
#include <queue>
#include <vector>
#include <iostream>
#include <set>
#include <algorithm>
#include <utility>

std::queue<std::vector<int>> maybe_neigh;

std::set<std::pair<int, int> > answers;

void maybe_answer(int u, int v) {
	if (u > v) std::swap(u, v);
	if (answers.find({u, v}) != answers.end()) return;
	answers.insert({u, v});
	answer(u, v);
}

void solve(int n) {
	std::vector<int> init;
	for (int i = 1; i <= n; i += 1) {
		init.push_back(i);
	}
	maybe_neigh.push(init);
	
	while (!maybe_neigh.empty()) {
		auto it = maybe_neigh.front();
		maybe_neigh.pop();
		if (it.size() < 2) continue;
		if (it.size() == 2) {
			maybe_answer(it[0], it[1]);
			continue;
		}
						
		std::vector<int> in  {};
		std::vector<int> uout{};
		std::vector<int> vout{};
		
		for (int i = 2; i < it.size(); i += 1) {
			if      (query({it[0], it[i]}, it[1])) vout.push_back(it[i]);
			else if (query({it[1], it[i]}, it[0])) uout.push_back(it[i]);
			else                                   in  .push_back(it[i]);
		}
		in.push_back(it[0]);
		in.push_back(it[1]);
		uout.push_back(it[0]);
		vout.push_back(it[1]);

		
		maybe_neigh.push(in);
		maybe_neigh.push(uout);
		maybe_neigh.push(vout);
	}
}
