#pragma GCC optimize("O3")

#include <iostream>

#define MAXN 2003

int n;
int arr[MAXN][MAXN];
int pfx[MAXN][MAXN];

int ans;

int sum_from_to(int y1, int x1, int y2, int x2) {
	y1 -= 1;
	x1 -= 1;
	return pfx[y2][x2] - pfx[y2][x1] - pfx[y1][x2] + pfx[y1][x1];
}

int area_from_to(int y1, int x1, int y2, int x2) {
	return (y2 - y1 + 1) * (x2 - x1 + 1);
}

int full_or_empty(int y1, int x1, int y2, int x2) {
	int sum = sum_from_to(y1, x1, y2, x2);
	int area = area_from_to(y1, x1, y2, x2);
	
	if (sum == area) return area;
	
	for (int h = 1; h-1 <= y2-y1; h += 1) {
		for (int w = 1; w-1 <= x2-x1; w += 1) {
			if (h * w != sum) continue;
			for (int i1 = y1; i1+h-1 <= y2; i1 += 1) {
				for (int j1 = x1; j1+w-1 <= x2; j1 += 1) {
					int i2 = i1+h-1;
					int j2 = j1+w-1;
					if(sum_from_to(i1, j1, i2, j2) != 0) continue;
					return area;
				}				
			}
		}
	}
	
	return 0;
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cout.tie(0);
	std::cin.tie(0);
	
	int ans = 0;
	
	std::cin >> n;
	for (int y = 1; y <= n; y +=1) {
		for (int x = 1; x <= n; x +=1) {
			char c;
			std::cin >> c;
			arr[y][x] = c == '1';
		}		
	}
	
	for (int y = 1; y <= n; y +=1) {
		for (int x = 1; x <= n; x +=1) {
			pfx[y][x] = arr[y][x] + pfx[y-1][x] + pfx[y][x-1] - pfx[y-1][x-1];
		}
	}
	
	for (int y1 = 1; y1 <= n; y1 +=1) {
		for (int x1 = 1; x1 <= n; x1 +=1) {
			for (int y2 = 1; y2 <= n; y2 +=1) {
				for (int x2 = 1; x2 <= n; x2 +=1) {
					ans = std::max(ans, full_or_empty(y1, x1, y2, x2));
				}
			}
		}
	}
	
	std::cout << ans << std::endl;
	
	return 0;
}