#pragma GCC optimize("O3")

#include <iostream>

#define MAXN 2003

int n;
int arr[MAXN][MAXN];
int pfx[MAXN][MAXN];

int ans;

int sum_from_to(int y1, int x1, int y2, int x2) {
	y1 -= 1;
	x1 -= 1;
	return pfx[y2][x2] - pfx[y2][x1] - pfx[y1][x2] + pfx[y1][x1];
}

int area_from_to(int y1, int x1, int y2, int x2) {
	return (y2 - y1 + 1) * (x2 - x1 + 1);
}

int full_or_empty(int y1, int x1, int y2, int x2) {
	int sum = sum_from_to(y1, x1, y2, x2);
	int area = area_from_to(y1, x1, y2, x2);
	int need = area - sum;
	
	if (sum == area) return area;
	
	int a, b;
	
	a = x1-1;
	b = x2;
	while (true) {
		if (a + 1 >= b) break;
		int m = (a+b) / 2;
		if (area_from_to(y1,x1,y2,m) == sum_from_to(y1,x1,y2,m)) {
			a = m;
		} else {
			b = m;
		}
	}
	int l = b;	
	
	a = x2+1;
	b = x1;
	while (true) {
		if (b + 1 >= a) break;
		int m = (a+b) / 2;
		if (area_from_to(y1,m,y2,x2) == sum_from_to(y1,m,y2,x2)) {
			a = m;
		} else {
			b = m;
		}
	}
	int r = b;

	a = y1-1;
	b = y2;
	while (true) {
		if (a + 1 >= b) break;
		int m = (a+b) / 2;
		if (area_from_to(y1,x1,m,x2) == sum_from_to(y1,x1,m,x2)) {
			a = m;
		} else {
			b = m;
		}
	}
	int u = b;
	
	a = y2+1;
	b = y1;
	while (true) {
		if (b + 1 >= a) break;
		int m = (a+b) / 2;
		if (area_from_to(m,x1,y2,x2) == sum_from_to(m,x1,y2,x2)) {
			a = m;
		} else {
			b = m;
		}
	}
	int d = b;
	
	if (area_from_to(u, l, d, r) == need) return area;
		
	return 0;
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cout.tie(0);
	std::cin.tie(0);
	
	int ans = 0;
	
	std::cin >> n;
	for (int y = 1; y <= n; y +=1) {
		for (int x = 1; x <= n; x +=1) {
			char c;
			std::cin >> c;
			arr[y][x] = c == '1';
		}		
	}
	
	for (int y = 1; y <= n; y +=1) {
		for (int x = 1; x <= n; x +=1) {
			pfx[y][x] = arr[y][x] + pfx[y-1][x] + pfx[y][x-1] - pfx[y-1][x-1];
		}
	}
	
	for (int y1 = 1; y1 <= n; y1 +=1) {
		for (int x1 = 1; x1 <= n; x1 +=1) {
			for (int y2 = y1; y2 <= n; y2 +=1) {
				for (int x2 = area / (y2-y1+1) + x1; x2 <= n; x2 +=1) {
					ans = std::max(ans, full_or_empty(y1, x1, y2, x2));
				}
			}
		}
	}
	
	std::cout << ans << std::endl;
	
	return 0;
}