/**
    Зам деле думля да
    зам деле думля да
    зам деле деле деле
    думля да да да да
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <set>

typedef long long llong;
const int MAXLOG = 12;
const int MAXN = 2000 + 10;
const int INF  = 1e9;

int n;
struct SparseMIN
{
    int sparse[MAXLOG][MAXN];
    int vals[MAXN];
    int lg[MAXN];

    int cmp(int x, int y)
    {
        if (vals[x] < vals[y]) return x;
        if (vals[x] > vals[y]) return y;
        return std::min(x, y);
    }

    void build(int _vals[])
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            vals[i] = _vals[i];
            sparse[0][i] = i;
        }

        for (int log = 1 ; (1 << log) <= n ; ++log)
        {
            for (int i = 1 ; i + (1 << log) - 1 <= n ; ++i)
            {
                sparse[log][i] = cmp(sparse[log - 1][i], sparse[log - 1][i + (1 << log - 1)]);
            }
        }

        lg[0] = 0;
        for (int i = 1 ; i <= n ; ++i)
        {
            lg[i] = lg[i - 1];
            if ((1 << lg[i] + 1) < i) lg[i]++;
        }
    }

    int query(int l, int r)
    {
        int log = lg[r - l + 1];
        return cmp(sparse[log][l], sparse[log][r - (1 << log) + 1]);
    }
};

struct SparseMAX
{
    int sparse[MAXLOG][MAXN];
    int vals[MAXN];
    int lg[MAXN];

    int cmp(int x, int y)
    {
        if (vals[x] > vals[y]) return x;
        if (vals[x] < vals[y]) return y;
        return std::max(x, y);
    }

    void build(int _vals[])
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            vals[i] = _vals[i];
            sparse[0][i] = i;
        }

        for (int log = 1 ; (1 << log) <= n ; ++log)
        {
            for (int i = 1 ; i + (1 << log) - 1 <= n ; ++i)
            {
                sparse[log][i] = cmp(sparse[log - 1][i], sparse[log - 1][i + (1 << log - 1)]);
            }
        }

        lg[0] = 0;
        for (int i = 1 ; i <= n ; ++i)
        {
            lg[i] = lg[i - 1];
            if ((1 << lg[i] + 1) < i) lg[i]++;
        }
    }

    int query(int l, int r)
    {
        int log = lg[r - l + 1];
        return cmp(sparse[log][l], sparse[log][r - (1 << log) + 1]);
    }
};

SparseMIN min[MAXN];
SparseMAX max[MAXN];
bool t[MAXN][MAXN];
char s[MAXN][MAXN];
int p[MAXN][MAXN];
int firstZero[MAXN][MAXN];
int lastZero[MAXN][MAXN];
std::vector <int> v;

int checkSum(int row1, int col1, int row2, int col2)
{
    --row1; --col1;
    return p[row2][col2] - p[row1][col2] - p[row2][col1] + p[row1][col1];
}

bool check(int row1, int col1, int row2, int col2)
{
    int minC = min[row1].query(col1, col2), minR = firstZero[row1][minC];
    int maxC = max[row2].query(col1, col2), maxR = lastZero[row2][maxC];
    if (minC > row2)
    {
        return true;
    }

    if (minC > maxC || minR > maxR)
    {
        return false;
    }

    int sum = checkSum(minR, minC, maxR, maxC);
    if (sum != checkSum(row1, col1, row2, col2))
    {
        return false;
    }

    if (sum != (maxR - minR + 1) * (maxC - minC + 1))
    {
        return false;
    }

    return true;
}

bool search(int r, int c)
{
    for (int i = 1 ; i + r - 1 <= n ; ++i)
    {
        for (int j = 1 ; j + c - 1 <= n ; ++j)
        {
            if (check(i, j, i + r - 1, j + c - 1))
            {
                return true;
            }
        }
    }

    return false;
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= n ; ++j)
        {
            p[i][j] = p[i - 1][j] + p[i][j - 1] - p[i - 1][j - 1] + 1 - t[i][j];
        }
    }

    for (int i = n ; i >= 1 ; --i)
    {
        firstZero[n + 1][i] = n + 1;
    }

    for (int i = n ; i >= 1 ; --i)
    {
        for (int j = 1 ; j <= n ; ++j)
        {
            if (t[i][j] == 1) firstZero[i][j] = firstZero[i + 1][j];
            else firstZero[i][j] = i;
        }

        min[i].build(firstZero[i]);
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        lastZero[0][i] = 0;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j = 1 ; j <= n ; ++j)
        {
            if (t[i][j] == 1) lastZero[i][j] = lastZero[i - 1][j];
            else lastZero[i][j] = i;
        }

        max[i].build(lastZero[i]);
    }

    int ans = 0;
    int ptr = n;
    for (int i = 1 ; i <= n ; ++i)
    {
        while (ptr > 0 && !search(i, ptr))
        {
            ptr--;
        }

        if (ptr == 0)
        {
            break;
        }

        ans = std::max(ans, i * ptr);
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> s[i] + 1;
        for (int j = 1 ; j <= n ; ++j)
        {
            t[i][j] = s[i][j] - '0';
        }
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}
